package com.fr.plugin.external;

import com.fr.cache.Attachment;
import com.fr.cache.type.AttachmentScope;
import com.fr.web.AttachmentHelper;

import java.awt.Image;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class ImageBean {

    private Image image;
    private Attachment attachment;

    public ImageBean(final Image image) {
        this.image = image;
        ExecutorService service = Executors.newSingleThreadExecutor();
        service.execute(new Runnable() {
            @Override
            public void run() {
                // 可能已经在主线程初始化了.
                if (attachment != null) {
                    attachment = AttachmentHelper.addAttachment(image, AttachmentScope.HOLDER);
                }
            }
        });
    }

    public Image getImage() {
        return image;
    }

    public void setImage(Image image) {
        this.image = image;
    }

    public Attachment getAttachment() {
        if (attachment == null) {
            attachment = AttachmentHelper.addAttachment(image, AttachmentScope.HOLDER);
        }

        return attachment;
    }

    public void setAttachment(Attachment attachment) {
        this.attachment = attachment;
    }
}
